package binaryclock.GUI;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;

public class BinClockFrame
    extends JFrame
    implements ActionListener {

  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();

  JRadioButton rbDef = new JRadioButton();

  JRadioButton rbDH_0 = new JRadioButton();
  JRadioButton rbDH_1 = new JRadioButton();
  JRadioButton rbDH_2 = new JRadioButton();
  JRadioButton rbDH_3 = new JRadioButton();

  JRadioButton rbJH_0 = new JRadioButton();
  JRadioButton rbJH_1 = new JRadioButton();
  JRadioButton rbJH_2 = new JRadioButton();
  JRadioButton rbJH_3 = new JRadioButton();

  JRadioButton rbDM_0 = new JRadioButton();
  JRadioButton rbDM_1 = new JRadioButton();
  JRadioButton rbDM_2 = new JRadioButton();
  JRadioButton rbDM_3 = new JRadioButton();

  JRadioButton rbJM_0 = new JRadioButton();
  JRadioButton rbJM_1 = new JRadioButton();
  JRadioButton rbJM_2 = new JRadioButton();
  JRadioButton rbJM_3 = new JRadioButton();

  JRadioButton rbDS_0 = new JRadioButton();
  JRadioButton rbDS_1 = new JRadioButton();
  JRadioButton rbDS_2 = new JRadioButton();
  JRadioButton rbDS_3 = new JRadioButton();

  JRadioButton rbJS_0 = new JRadioButton();
  JRadioButton rbJS_1 = new JRadioButton();
  JRadioButton rbJS_2 = new JRadioButton();
  JRadioButton rbJS_3 = new JRadioButton();

  JPanel contentPane;
  JPanel pnlMain = new JPanel();
  JPanel pnlClockNormal = new JPanel();
  JPanel pnlClockBinary = new JPanel();

  JLabel clockHD = new JLabel();
  JLabel clockHJ = new JLabel();
  JLabel clockMD = new JLabel();
  JLabel clockMJ = new JLabel();
  JLabel clockSD = new JLabel();
  JLabel clockSJ = new JLabel();
  JLabel doubleDot01 = new JLabel();
  JLabel doubleDot02 = new JLabel();

  JLabel doubleDot11 = new JLabel();
  JLabel doubleDot12 = new JLabel();

  Dimension dimPnlMain = new Dimension(200, 160);
  Dimension dimFrame = new Dimension(200, 160);
  Dimension dimPnlClockNormal = new Dimension(200, 40);
  Dimension dimPnlClockBinary = new Dimension(200, 100);
  Dimension dimClock = new Dimension(100, 30);

  Timer timer = new Timer(100, this);
  GridBagLayout gridBagLayout3 = new GridBagLayout();
// -----------------------------------------------------------------------------
  public BinClockFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      initListeners();
      timer.start();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

// -----------------------------------------------------------------------------
  private void jbInit() {
    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(new BorderLayout());
    contentPane.setMinimumSize(dimFrame);
    contentPane.setPreferredSize(dimFrame);
    this.setDefaultCloseOperation(HIDE_ON_CLOSE);
    this.setResizable(false);
    this.setSize(dimPnlMain);
    this.setState(Frame.NORMAL);
    this.setTitle("Binary Clock");

    // labels
    clockHD.setFont(new java.awt.Font("Dialog", 1, 26));
    clockHJ.setFont(new java.awt.Font("Dialog", 1, 26));
    clockMD.setFont(new java.awt.Font("Dialog", 1, 26));
    clockMJ.setFont(new java.awt.Font("Dialog", 1, 26));
    clockSD.setFont(new java.awt.Font("Dialog", 1, 26));
    clockSJ.setFont(new java.awt.Font("Dialog", 1, 26));

    // panel clock normal
    pnlClockNormal.setBorder(BorderFactory.createEmptyBorder());
    pnlClockNormal.setMinimumSize(dimPnlClockNormal);
    pnlClockNormal.setPreferredSize(dimPnlClockNormal);
    pnlClockNormal.setLayout(gridBagLayout2);

    doubleDot01.setText(":");
    doubleDot01.setFont(new java.awt.Font("Dialog", 1, 26));
    doubleDot02.setText(":");
    doubleDot02.setFont(new java.awt.Font("Dialog", 1, 26));

    pnlClockNormal.add(clockHD, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockNormal.add(clockHJ, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockNormal.add(doubleDot01, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockNormal.add(clockMD, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockNormal.add(clockMJ, new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockNormal.add(doubleDot02, new GridBagConstraints(5, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockNormal.add(clockSD, new GridBagConstraints(6, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockNormal.add(clockSJ, new GridBagConstraints(7, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.WEST, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    // panel clock binary
    pnlClockBinary.setBorder(BorderFactory.createEmptyBorder());
    pnlClockBinary.setMinimumSize(dimPnlClockBinary);
    pnlClockBinary.setPreferredSize(dimPnlClockBinary);
    pnlClockBinary.setLayout(gridBagLayout1);

    rbDef.setText("");
    rbDef.setSelected(true);

    rbDH_0.setText("");
    rbDH_1.setText("");
    rbDH_2.setText("");
    rbDH_3.setText("");

    rbJH_0.setText("");
    rbJH_1.setText("");
    rbJH_2.setText("");
    rbJH_3.setText("");

    rbDM_0.setText("");
    rbDM_1.setText("");
    rbDM_2.setText("");
    rbDM_3.setText("");

    rbJM_0.setText("");
    rbJM_1.setText("");
    rbJM_2.setText("");
    rbJM_3.setText("");

    rbDS_0.setText("");
    rbDS_1.setText("");
    rbDS_2.setText("");
    rbDS_3.setText("");

    rbJS_0.setText("");
    rbJS_1.setText("");
    rbJS_2.setText("");
    rbJS_3.setText("");

    rbDH_0.setEnabled(false);
    rbDH_1.setEnabled(false);
    rbDH_2.setEnabled(false);
    rbDH_3.setEnabled(false);

    rbJH_0.setEnabled(false);
    rbJH_1.setEnabled(false);
    rbJH_2.setEnabled(false);
    rbJH_3.setEnabled(false);

    rbDM_0.setEnabled(false);
    rbDM_1.setEnabled(false);
    rbDM_2.setEnabled(false);
    rbDM_3.setEnabled(false);

    rbJM_0.setEnabled(false);
    rbJM_1.setEnabled(false);
    rbJM_2.setEnabled(false);
    rbJM_3.setEnabled(false);

    rbDS_0.setEnabled(false);
    rbDS_1.setEnabled(false);
    rbDS_2.setEnabled(false);
    rbDS_3.setEnabled(false);

    rbJS_0.setEnabled(false);
    rbJS_1.setEnabled(false);
    rbJS_2.setEnabled(false);
    rbJS_3.setEnabled(false);

    doubleDot11.setText(":");
    doubleDot11.setFont(new java.awt.Font("Dialog", 1, 26));
    doubleDot12.setText(":");
    doubleDot12.setFont(new java.awt.Font("Dialog", 1, 26));

    pnlClockBinary.add(rbDH_3, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDH_2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDH_1, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDH_0, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(rbJH_3, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJH_2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJH_1, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJH_0, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.NORTH, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(doubleDot11, new GridBagConstraints(2, 0, 1, 4, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(rbDM_3, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDM_2, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDM_1, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDM_0, new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(rbJM_3, new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJM_2, new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJM_1, new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJM_0, new GridBagConstraints(4, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.NORTH, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(doubleDot12, new GridBagConstraints(5, 0, 1, 4, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(rbDS_3, new GridBagConstraints(6, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDS_2, new GridBagConstraints(6, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDS_1, new GridBagConstraints(6, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbDS_0, new GridBagConstraints(6, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    pnlClockBinary.add(rbJS_3, new GridBagConstraints(7, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJS_2, new GridBagConstraints(7, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJS_1, new GridBagConstraints(7, 2, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlClockBinary.add(rbJS_0, new GridBagConstraints(7, 3, 1, 1, 0.0, 0.0
        , GridBagConstraints.NORTH, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    // panel Main

    pnlMain.setLayout(gridBagLayout3);
    pnlMain.setBorder(BorderFactory.createEmptyBorder());
    pnlMain.setMinimumSize(dimPnlMain);
    pnlMain.setPreferredSize(dimPnlMain);

    pnlMain.add(pnlClockNormal, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));
    pnlMain.add(pnlClockBinary, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(0, 0, 0, 0), 0, 0));

    contentPane.add(pnlMain, BorderLayout.CENTER);
  }

// -----------------------------------------------------------------------------
  private void initListeners() {}

// -----------------------------------------------------------------------------
  public void actionPerformed(ActionEvent e) {
    if (e.getSource().equals(timer)) {
      updateClock();
    }
  }

// -----------------------------------------------------------------------------
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      exit_AP(null);
    }
  }

// -----------------------------------------------------------------------------
  private void exit_AP(ActionEvent e) {
    System.exit(0);
  }

// -----------------------------------------------------------------------------
  private void updateClock() {
    Date dat = new Date();

    String strTime = dat.toString().substring(11, 19);
    String hourD = strTime.substring(0, 1);
    String hourJ = strTime.substring(1, 2);
    String minD = strTime.substring(3, 4);
    String minJ = strTime.substring(4, 5);
    String secD = strTime.substring(6, 7);
    String secJ = strTime.substring(7, 8);

    clockHD.setText(hourD);
    clockHJ.setText(hourJ);

    clockMD.setText(minD);
    clockMJ.setText(minJ);

    clockSD.setText(secD);
    clockSJ.setText(secJ);

    setDigit(rbDH_0, rbDH_1, rbDH_2, rbDH_3, hourD);
    setDigit(rbJH_0, rbJH_1, rbJH_2, rbJH_3, hourJ);

    setDigit(rbDM_0, rbDM_1, rbDM_2, rbDM_3, minD);
    setDigit(rbJM_0, rbJM_1, rbJM_2, rbJM_3, minJ);

    setDigit(rbDS_0, rbDS_1, rbDS_2, rbDS_3, secD);
    setDigit(rbJS_0, rbJS_1, rbJS_2, rbJS_3, secJ);
  }

// -----------------------------------------------------------------------------
  private void setDigit(JRadioButton rb0, JRadioButton rb1, JRadioButton rb2,
                        JRadioButton rb3, String digit) {
    if (digit.equals("0")) {
      rb0.setSelected(false);
      rb1.setSelected(false);
      rb2.setSelected(false);
      rb3.setSelected(false);
    }
    else if (digit.equals("1")) {
      rb0.setSelected(true);
      rb1.setSelected(false);
      rb2.setSelected(false);
      rb3.setSelected(false);
    }
    else if (digit.equals("2")) {
      rb0.setSelected(false);
      rb1.setSelected(true);
      rb2.setSelected(false);
      rb3.setSelected(false);
    }
    else if (digit.equals("3")) {
      rb0.setSelected(true);
      rb1.setSelected(true);
      rb2.setSelected(false);
      rb3.setSelected(false);
    }
    else if (digit.equals("4")) {
      rb0.setSelected(false);
      rb1.setSelected(false);
      rb2.setSelected(true);
      rb3.setSelected(false);
    }
    else if (digit.equals("5")) {
      rb0.setSelected(true);
      rb1.setSelected(false);
      rb2.setSelected(true);
      rb3.setSelected(false);
    }
    else if (digit.equals("6")) {
      rb0.setSelected(false);
      rb1.setSelected(true);
      rb2.setSelected(true);
      rb3.setSelected(false);
    }
    else if (digit.equals("7")) {
      rb0.setSelected(true);
      rb1.setSelected(true);
      rb2.setSelected(true);
      rb3.setSelected(false);
    }
    else if (digit.equals("8")) {
      rb0.setSelected(false);
      rb1.setSelected(false);
      rb2.setSelected(false);
      rb3.setSelected(true);
    }
    else if (digit.equals("9")) {
      rb0.setSelected(true);
      rb1.setSelected(false);
      rb2.setSelected(false);
      rb3.setSelected(true);
    }
  }

// -----------------------------------------------------------------------------
} // end of class
